library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

-- LRRequestBuffer_in : separates left and right channel and forward it into each processing unit

entity LRRequestBuffer_in is
port (
    clk : in std_logic;    
	lrck : in std_logic;
    audio_req : in std_logic;
    data_in : in std_logic_vector (15 downto 0);	

	data_left : out std_logic;
	data_right : out std_logic;
    dataL_out : out std_logic_vector(15 downto 0);
    dataR_out : out std_logic_vector(15 downto 0)
    
  );
end  LRRequestBuffer_in;


architecture Behavioral of  LRRequestBuffer_in is     

signal state : std_logic := '0';
-- signal prev_lrck : std_logic;
	
begin
    process(clk)
    begin
    	--if audio request is 1 check to see if its rising edge or falling edge
		if(clk 'event and clk = '1') then
--			prev_lrck <= lrck;
	    	if(audio_req = '1') then
			   if(state = '0') then
		    	   if(lrck = '1') then --if clk is up there then shift out as right channel (1 clk later)
					 data_right <= '1';
					 data_left <= '0';
		    	     dataR_out <= data_in;
					 state <= '1';
		    	   else
					 data_left <= '1';
					 data_right <= '0';
		    	     dataL_out <= data_in;
					 state <= '1';
		    	   end if;
				else
					data_right <= '0';
					data_left <= '0';
				end if;
			 else
				data_right <= '0';
				data_left <= '0';
				state <= '0';
	    	 end if;
		end if;
    end process;  			    
end Behavioral;




