library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity mux is 
port (
	--Inputs
	data1_in : in std_logic_vector(15 downto 0);
	data2_in : in std_logic_vector(15 downto 0);
	
	--Input from Switch Module
	selector : in std_logic;
	
	--Output
	dataout : out std_logic_vector(15 downto 0)
);
end mux;

architecture rtl of mux is

begin

process(selector)
begin
	if (selector = '0') then
		dataout <= data1_in;
	end if;
	if (selector = '1') then
		dataout <= data2_in;
	end if;	 
end process;

end rtl;