--Legal Notice: (C)2006 Altera Corporation. All rights reserved.  Your
--use of Altera Corporation's design tools, logic functions and other
--software and tools, and its AMPP partner logic functions, and any
--output files any of the foregoing (including device programming or
--simulation files), and any associated documentation or information are
--expressly subject to the terms and conditions of the Altera Program
--License Subscription Agreement or other applicable license agreement,
--including, without limitation, that your use is for the sole purpose
--of programming logic devices manufactured by Altera and sold by Altera
--or its authorized distributors.  Please refer to the applicable
--agreement for further details.


-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity adapter_slave_y_0_readdatavalid_fifo_module is 
        port (
              -- inputs:
                 signal clear_fifo : IN STD_LOGIC;
                 signal clk : IN STD_LOGIC;
                 signal data_in : IN STD_LOGIC;
                 signal read : IN STD_LOGIC;
                 signal reset_n : IN STD_LOGIC;
                 signal sync_reset : IN STD_LOGIC;
                 signal write : IN STD_LOGIC;

              -- outputs:
                 signal data_out : OUT STD_LOGIC;
                 signal empty : OUT STD_LOGIC;
                 signal fifo_contains_ones_n : OUT STD_LOGIC;
                 signal full : OUT STD_LOGIC
              );
end entity adapter_slave_y_0_readdatavalid_fifo_module;


architecture europa of adapter_slave_y_0_readdatavalid_fifo_module is
                signal full_0 :  STD_LOGIC;
                signal full_1 :  STD_LOGIC;
                signal full_2 :  STD_LOGIC;
                signal full_3 :  STD_LOGIC;
                signal how_many_ones :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal one_count_minus_one :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal one_count_plus_one :  STD_LOGIC_VECTOR (2 DOWNTO 0);
                signal p0_full_0 :  STD_LOGIC;
                signal p0_stage_0 :  STD_LOGIC;
                signal p1_full_1 :  STD_LOGIC;
                signal p1_stage_1 :  STD_LOGIC;
                signal p2_full_2 :  STD_LOGIC;
                signal p2_stage_2 :  STD_LOGIC;
                signal stage_0 :  STD_LOGIC;
                signal stage_1 :  STD_LOGIC;
                signal stage_2 :  STD_LOGIC;
                signal updated_one_count :  STD_LOGIC_VECTOR (2 DOWNTO 0);

begin

  data_out <= stage_0;
  full <= full_2;
  empty <= NOT(full_0);
  full_3 <= std_logic'('0');
  --data_2, which is an e_mux
  p2_stage_2 <= A_WE_StdLogic((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((full_3 AND NOT clear_fifo))))) = std_logic_vector'("00000000000000000000000000000000"))), data_in, data_in);
  --data_reg_2, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      stage_2 <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((clear_fifo OR sync_reset) OR read) OR ((write AND NOT(full_2))))) = '1' then 
        if std_logic'(((sync_reset AND full_2) AND NOT((((to_std_logic((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(full_3))) = std_logic_vector'("00000000000000000000000000000000")))) AND read) AND write))))) = '1' then 
          stage_2 <= std_logic'('0');
        else
          stage_2 <= p2_stage_2;
        end if;
      end if;
    end if;

  end process;

  --control_2, which is an e_mux
  p2_full_2 <= Vector_To_Std_Logic(A_WE_StdLogicVector((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((read AND NOT(write)))))) = std_logic_vector'("00000000000000000000000000000000"))), (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(full_1))), std_logic_vector'("00000000000000000000000000000000")));
  --control_reg_2, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      full_2 <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(((clear_fifo OR ((read XOR write))) OR ((write AND NOT(full_0))))) = '1' then 
        if std_logic'(clear_fifo) = '1' then 
          full_2 <= std_logic'('0');
        else
          full_2 <= p2_full_2;
        end if;
      end if;
    end if;

  end process;

  --data_1, which is an e_mux
  p1_stage_1 <= A_WE_StdLogic((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((full_2 AND NOT clear_fifo))))) = std_logic_vector'("00000000000000000000000000000000"))), data_in, stage_2);
  --data_reg_1, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      stage_1 <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((clear_fifo OR sync_reset) OR read) OR ((write AND NOT(full_1))))) = '1' then 
        if std_logic'(((sync_reset AND full_1) AND NOT((((to_std_logic((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(full_2))) = std_logic_vector'("00000000000000000000000000000000")))) AND read) AND write))))) = '1' then 
          stage_1 <= std_logic'('0');
        else
          stage_1 <= p1_stage_1;
        end if;
      end if;
    end if;

  end process;

  --control_1, which is an e_mux
  p1_full_1 <= A_WE_StdLogic((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((read AND NOT(write)))))) = std_logic_vector'("00000000000000000000000000000000"))), full_0, full_2);
  --control_reg_1, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      full_1 <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(((clear_fifo OR ((read XOR write))) OR ((write AND NOT(full_0))))) = '1' then 
        if std_logic'(clear_fifo) = '1' then 
          full_1 <= std_logic'('0');
        else
          full_1 <= p1_full_1;
        end if;
      end if;
    end if;

  end process;

  --data_0, which is an e_mux
  p0_stage_0 <= A_WE_StdLogic((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((full_1 AND NOT clear_fifo))))) = std_logic_vector'("00000000000000000000000000000000"))), data_in, stage_1);
  --data_reg_0, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      stage_0 <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((((clear_fifo OR sync_reset) OR read) OR ((write AND NOT(full_0))))) = '1' then 
        if std_logic'(((sync_reset AND full_0) AND NOT((((to_std_logic((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(full_1))) = std_logic_vector'("00000000000000000000000000000000")))) AND read) AND write))))) = '1' then 
          stage_0 <= std_logic'('0');
        else
          stage_0 <= p0_stage_0;
        end if;
      end if;
    end if;

  end process;

  --control_0, which is an e_mux
  p0_full_0 <= Vector_To_Std_Logic(A_WE_StdLogicVector((((std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(((read AND NOT(write)))))) = std_logic_vector'("00000000000000000000000000000000"))), std_logic_vector'("00000000000000000000000000000001"), (std_logic_vector'("0000000000000000000000000000000") & (A_TOSTDLOGICVECTOR(full_1)))));
  --control_reg_0, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      full_0 <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'(((clear_fifo OR ((read XOR write))) OR ((write AND NOT(full_0))))) = '1' then 
        if std_logic'((clear_fifo AND NOT write)) = '1' then 
          full_0 <= std_logic'('0');
        else
          full_0 <= p0_full_0;
        end if;
      end if;
    end if;

  end process;

  one_count_plus_one <= A_EXT (((std_logic_vector'("000000000000000000000000000000") & (how_many_ones)) + std_logic_vector'("000000000000000000000000000000001")), 3);
  one_count_minus_one <= A_EXT (((std_logic_vector'("000000000000000000000000000000") & (how_many_ones)) - std_logic_vector'("000000000000000000000000000000001")), 3);
  --updated_one_count, which is an e_mux
  updated_one_count <= A_EXT (A_WE_StdLogicVector((std_logic'(((((clear_fifo OR sync_reset)) AND NOT(write)))) = '1'), std_logic_vector'("00000000000000000000000000000000"), (std_logic_vector'("00000000000000000000000000000") & (A_WE_StdLogicVector((std_logic'(((((clear_fifo OR sync_reset)) AND write))) = '1'), (std_logic_vector'("00") & (A_TOSTDLOGICVECTOR(data_in))), A_WE_StdLogicVector((std_logic'(((((read AND (data_in)) AND write) AND (stage_0)))) = '1'), how_many_ones, A_WE_StdLogicVector((std_logic'(((write AND (data_in)))) = '1'), one_count_plus_one, A_WE_StdLogicVector((std_logic'(((read AND (stage_0)))) = '1'), one_count_minus_one, how_many_ones))))))), 3);
  --counts how many ones in the data pipeline, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      how_many_ones <= std_logic_vector'("000");
    elsif clk'event and clk = '1' then
      if std_logic'((((clear_fifo OR sync_reset) OR read) OR write)) = '1' then 
        how_many_ones <= updated_one_count;
      end if;
    end if;

  end process;

  --this fifo contains ones in the data pipeline, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      fifo_contains_ones_n <= std_logic'('1');
    elsif clk'event and clk = '1' then
      if std_logic'((((clear_fifo OR sync_reset) OR read) OR write)) = '1' then 
        fifo_contains_ones_n <= NOT (or_reduce(updated_one_count));
      end if;
    end if;

  end process;


end europa;



-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

library std;
use std.textio.all;

entity adapter_slave_y_0 is 
        port (
              -- inputs:
                 signal a_upstream_address : IN STD_LOGIC_VECTOR (10 DOWNTO 0);
                 signal a_upstream_arbiterlock : IN STD_LOGIC;
                 signal a_upstream_arbiterlock2 : IN STD_LOGIC;
                 signal a_upstream_burstcount : IN STD_LOGIC;
                 signal a_upstream_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal a_upstream_chipselect : IN STD_LOGIC;
                 signal a_upstream_debugaccess : IN STD_LOGIC;
                 signal a_upstream_nativeaddress : IN STD_LOGIC_VECTOR (8 DOWNTO 0);
                 signal a_upstream_read : IN STD_LOGIC;
                 signal a_upstream_write : IN STD_LOGIC;
                 signal a_upstream_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal b_upstream_address : IN STD_LOGIC_VECTOR (10 DOWNTO 0);
                 signal b_upstream_arbiterlock : IN STD_LOGIC;
                 signal b_upstream_arbiterlock2 : IN STD_LOGIC;
                 signal b_upstream_burstcount : IN STD_LOGIC;
                 signal b_upstream_byteenable : IN STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal b_upstream_chipselect : IN STD_LOGIC;
                 signal b_upstream_debugaccess : IN STD_LOGIC;
                 signal b_upstream_nativeaddress : IN STD_LOGIC_VECTOR (8 DOWNTO 0);
                 signal b_upstream_read : IN STD_LOGIC;
                 signal b_upstream_write : IN STD_LOGIC;
                 signal b_upstream_writedata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal clk : IN STD_LOGIC;
                 signal downstream_endofpacket : IN STD_LOGIC;
                 signal downstream_readdata : IN STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal downstream_readdatavalid : IN STD_LOGIC;
                 signal downstream_waitrequest : IN STD_LOGIC;
                 signal reset_n : IN STD_LOGIC;

              -- outputs:
                 signal a_upstream_endofpacket : OUT STD_LOGIC;
                 signal a_upstream_readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal a_upstream_readdatavalid : OUT STD_LOGIC;
                 signal a_upstream_waitrequest : OUT STD_LOGIC;
                 signal b_upstream_endofpacket : OUT STD_LOGIC;
                 signal b_upstream_readdata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0);
                 signal b_upstream_readdatavalid : OUT STD_LOGIC;
                 signal b_upstream_waitrequest : OUT STD_LOGIC;
                 signal downstream_address : OUT STD_LOGIC_VECTOR (10 DOWNTO 0);
                 signal downstream_arbiterlock : OUT STD_LOGIC;
                 signal downstream_arbiterlock2 : OUT STD_LOGIC;
                 signal downstream_burstcount : OUT STD_LOGIC;
                 signal downstream_byteenable : OUT STD_LOGIC_VECTOR (3 DOWNTO 0);
                 signal downstream_chipselect : OUT STD_LOGIC;
                 signal downstream_debugaccess : OUT STD_LOGIC;
                 signal downstream_nativeaddress : OUT STD_LOGIC_VECTOR (8 DOWNTO 0);
                 signal downstream_read : OUT STD_LOGIC;
                 signal downstream_write : OUT STD_LOGIC;
                 signal downstream_writedata : OUT STD_LOGIC_VECTOR (31 DOWNTO 0)
              );
end entity adapter_slave_y_0;


architecture europa of adapter_slave_y_0 is
component adapter_slave_y_0_readdatavalid_fifo_module is 
           port (
                 -- inputs:
                    signal clear_fifo : IN STD_LOGIC;
                    signal clk : IN STD_LOGIC;
                    signal data_in : IN STD_LOGIC;
                    signal read : IN STD_LOGIC;
                    signal reset_n : IN STD_LOGIC;
                    signal sync_reset : IN STD_LOGIC;
                    signal write : IN STD_LOGIC;

                 -- outputs:
                    signal data_out : OUT STD_LOGIC;
                    signal empty : OUT STD_LOGIC;
                    signal fifo_contains_ones_n : OUT STD_LOGIC;
                    signal full : OUT STD_LOGIC
                 );
end component adapter_slave_y_0_readdatavalid_fifo_module;

                signal a_granted_this_time :  STD_LOGIC;
                signal b_granted_this_time :  STD_LOGIC;
                signal data_out :  STD_LOGIC;
                signal empty :  STD_LOGIC;
                signal full :  STD_LOGIC;
                signal internal_downstream_chipselect :  STD_LOGIC;
                signal internal_downstream_read :  STD_LOGIC;
                signal module_input :  STD_LOGIC;
                signal module_input1 :  STD_LOGIC;
                signal slave_starts_reading :  STD_LOGIC;

begin

  --b_upstream, which is an e_avalon_adapter_slave
  --a_upstream, which is an e_avalon_adapter_slave
  --downstream, which is an e_avalon_adapter_master
  --a grant register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      a_granted_this_time <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((NOT downstream_waitrequest OR ((NOT a_upstream_chipselect AND NOT b_upstream_chipselect)))) = '1' then 
        a_granted_this_time <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(NOT a_upstream_chipselect) = '1'), std_logic_vector'("00000000000000000000000000000000"), A_WE_StdLogicVector((std_logic'((a_upstream_chipselect AND NOT b_upstream_chipselect)) = '1'), std_logic_vector'("00000000000000000000000000000001"), A_WE_StdLogicVector((std_logic'((a_granted_this_time AND a_upstream_arbiterlock2)) = '1'), std_logic_vector'("00000000000000000000000000000001"), A_WE_StdLogicVector((std_logic'((NOT a_granted_this_time AND NOT b_granted_this_time)) = '1'), std_logic_vector'("00000000000000000000000000000001"), A_WE_StdLogicVector((std_logic'((NOT a_granted_this_time AND NOT b_upstream_arbiterlock2)) = '1'), std_logic_vector'("00000000000000000000000000000001"), std_logic_vector'("00000000000000000000000000000000")))))));
      end if;
    end if;

  end process;

  --b grant register, which is an e_register
  process (clk, reset_n)
  begin
    if reset_n = '0' then
      b_granted_this_time <= std_logic'('0');
    elsif clk'event and clk = '1' then
      if std_logic'((NOT downstream_waitrequest OR ((NOT a_upstream_chipselect AND NOT b_upstream_chipselect)))) = '1' then 
        b_granted_this_time <= Vector_To_Std_Logic(A_WE_StdLogicVector((std_logic'(NOT b_upstream_chipselect) = '1'), std_logic_vector'("00000000000000000000000000000000"), A_WE_StdLogicVector((std_logic'((b_upstream_chipselect AND NOT a_upstream_chipselect)) = '1'), std_logic_vector'("00000000000000000000000000000001"), A_WE_StdLogicVector((std_logic'((b_granted_this_time AND b_upstream_arbiterlock2)) = '1'), std_logic_vector'("00000000000000000000000000000001"), A_WE_StdLogicVector((std_logic'((NOT a_granted_this_time AND NOT b_granted_this_time)) = '1'), std_logic_vector'("00000000000000000000000000000000"), A_WE_StdLogicVector((std_logic'((NOT b_granted_this_time AND NOT a_upstream_arbiterlock2)) = '1'), std_logic_vector'("00000000000000000000000000000001"), std_logic_vector'("00000000000000000000000000000000")))))));
      end if;
    end if;

  end process;

  downstream_arbiterlock2 <= ((a_granted_this_time AND ((a_upstream_arbiterlock2 OR b_upstream_chipselect)))) OR ((b_granted_this_time AND b_upstream_arbiterlock2));
  a_upstream_waitrequest <= downstream_waitrequest OR NOT a_granted_this_time;
  b_upstream_waitrequest <= downstream_waitrequest OR NOT b_granted_this_time;
  internal_downstream_chipselect <= (a_granted_this_time AND a_upstream_chipselect) OR (b_granted_this_time AND b_upstream_chipselect);
  --slave_starts_reading, which is an e_assign
  slave_starts_reading <= (internal_downstream_read AND internal_downstream_chipselect) AND NOT downstream_waitrequest;
  --adapter_slave_y_0_readdatavalid_fifo, which is an e_fifo_with_registered_outputs
  adapter_slave_y_0_readdatavalid_fifo : adapter_slave_y_0_readdatavalid_fifo_module
    port map(
      data_out => data_out,
      empty => empty,
      fifo_contains_ones_n => open,
      full => full,
      clear_fifo => module_input,
      clk => clk,
      data_in => a_granted_this_time,
      read => downstream_readdatavalid,
      reset_n => reset_n,
      sync_reset => module_input1,
      write => slave_starts_reading
    );

  module_input <= std_logic'('0');
  module_input1 <= std_logic'('0');

  a_upstream_readdatavalid <= downstream_readdatavalid AND data_out;
  b_upstream_readdatavalid <= downstream_readdatavalid AND NOT data_out;
  b_upstream_endofpacket <= downstream_endofpacket;
  b_upstream_readdata <= downstream_readdata;
  --mux downstream_address between a and b
  downstream_address <= A_WE_StdLogicVector((std_logic'((a_granted_this_time)) = '1'), a_upstream_address, b_upstream_address);
  --mux downstream_arbiterlock between a and b
  downstream_arbiterlock <= A_WE_StdLogic((std_logic'((a_granted_this_time)) = '1'), a_upstream_arbiterlock, b_upstream_arbiterlock);
  --mux downstream_burstcount between a and b
  downstream_burstcount <= A_WE_StdLogic((std_logic'((a_granted_this_time)) = '1'), a_upstream_burstcount, b_upstream_burstcount);
  --mux downstream_byteenable between a and b
  downstream_byteenable <= A_WE_StdLogicVector((std_logic'((a_granted_this_time)) = '1'), a_upstream_byteenable, b_upstream_byteenable);
  --mux downstream_debugaccess between a and b
  downstream_debugaccess <= A_WE_StdLogic((std_logic'((a_granted_this_time)) = '1'), a_upstream_debugaccess, b_upstream_debugaccess);
  --mux downstream_nativeaddress between a and b
  downstream_nativeaddress <= A_WE_StdLogicVector((std_logic'((a_granted_this_time)) = '1'), a_upstream_nativeaddress, b_upstream_nativeaddress);
  --mux downstream_read between a and b
  internal_downstream_read <= A_WE_StdLogic((std_logic'((a_granted_this_time)) = '1'), a_upstream_read, b_upstream_read);
  --mux downstream_write between a and b
  downstream_write <= A_WE_StdLogic((std_logic'((a_granted_this_time)) = '1'), a_upstream_write, b_upstream_write);
  --mux downstream_writedata between a and b
  downstream_writedata <= A_WE_StdLogicVector((std_logic'((a_granted_this_time)) = '1'), a_upstream_writedata, b_upstream_writedata);
  a_upstream_endofpacket <= downstream_endofpacket;
  a_upstream_readdata <= downstream_readdata;
  --vhdl renameroo for output signals
  downstream_chipselect <= internal_downstream_chipselect;
  --vhdl renameroo for output signals
  downstream_read <= internal_downstream_read;
--synthesis translate_off
    --only one grant at a time, which is an e_process
    process (clk)
    VARIABLE write_line : line;
    begin
      if clk'event and clk = '1' then
        if std_logic'((a_granted_this_time AND b_granted_this_time)) = '1' then 
          write(write_line, now);
          write(write_line, string'(": "));
          write(write_line, string'("adapter_slave_y_0: a_granted_this_time, b_granted_this_time are active simultaneously."));
          write(output, write_line.all);
          deallocate (write_line);
          assert false report "VHDL STOP" severity failure;
        end if;
      end if;

    end process;

--synthesis translate_on

end europa;

