--Legal Notice: (C)2006 Altera Corporation. All rights reserved.  Your
--use of Altera Corporation's design tools, logic functions and other
--software and tools, and its AMPP partner logic functions, and any
--output files any of the foregoing (including device programming or
--simulation files), and any associated documentation or information are
--expressly subject to the terms and conditions of the Altera Program
--License Subscription Agreement or other applicable license agreement,
--including, without limitation, that your use is for the sole purpose
--of programming logic devices manufactured by Altera and sold by Altera
--or its authorized distributors.  Please refer to the applicable
--agreement for further details.


-- turn off superfluous VHDL processor warnings 
-- altera message_level Level1 
-- altera message_off 10034 10035 10036 10037 10230 10240 10030 

library altera;
use altera.altera_europa_support_lib.all;

library ieee;
use ieee.std_logic_1164.all;
use ieee.std_logic_arith.all;
use ieee.std_logic_unsigned.all;

entity adapter_waitrequest_pipeline_3 is 
        port (
              -- inputs:
                 signal reset_n : IN STD_LOGIC;
                 signal upstream_address : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal upstream_arbiterlock : IN STD_LOGIC;
                 signal upstream_arbiterlock2 : IN STD_LOGIC;
                 signal upstream_burstcount : IN STD_LOGIC;
                 signal upstream_byteenable : IN STD_LOGIC;
                 signal upstream_chipselect : IN STD_LOGIC;
                 signal upstream_debugaccess : IN STD_LOGIC;
                 signal upstream_nativeaddress : IN STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal upstream_read : IN STD_LOGIC;
                 signal upstream_write : IN STD_LOGIC;
                 signal upstream_writedata : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal waitrequest_clk : IN STD_LOGIC;
                 signal waitrequest_endofpacket : IN STD_LOGIC;
                 signal waitrequest_readdata : IN STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal waitrequest_readdatavalid : IN STD_LOGIC;
                 signal waitrequest_reset_n : IN STD_LOGIC;
                 signal waitrequest_waitrequest : IN STD_LOGIC;

              -- outputs:
                 signal upstream_endofpacket : OUT STD_LOGIC;
                 signal upstream_readdata : OUT STD_LOGIC_VECTOR (7 DOWNTO 0);
                 signal upstream_readdatavalid : OUT STD_LOGIC;
                 signal upstream_waitrequest : OUT STD_LOGIC;
                 signal waitrequest_address : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal waitrequest_arbiterlock : OUT STD_LOGIC;
                 signal waitrequest_arbiterlock2 : OUT STD_LOGIC;
                 signal waitrequest_burstcount : OUT STD_LOGIC;
                 signal waitrequest_byteenable : OUT STD_LOGIC;
                 signal waitrequest_chipselect : OUT STD_LOGIC;
                 signal waitrequest_debugaccess : OUT STD_LOGIC;
                 signal waitrequest_nativeaddress : OUT STD_LOGIC_VECTOR (1 DOWNTO 0);
                 signal waitrequest_read : OUT STD_LOGIC;
                 signal waitrequest_write : OUT STD_LOGIC;
                 signal waitrequest_writedata : OUT STD_LOGIC_VECTOR (7 DOWNTO 0)
              );
end entity adapter_waitrequest_pipeline_3;


architecture europa of adapter_waitrequest_pipeline_3 is
                signal d1_upstream_address :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal d1_upstream_arbiterlock :  STD_LOGIC;
                signal d1_upstream_arbiterlock2 :  STD_LOGIC;
                signal d1_upstream_burstcount :  STD_LOGIC;
                signal d1_upstream_byteenable :  STD_LOGIC;
                signal d1_upstream_chipselect :  STD_LOGIC;
                signal d1_upstream_debugaccess :  STD_LOGIC;
                signal d1_upstream_nativeaddress :  STD_LOGIC_VECTOR (1 DOWNTO 0);
                signal d1_upstream_read :  STD_LOGIC;
                signal d1_upstream_write :  STD_LOGIC;
                signal d1_upstream_writedata :  STD_LOGIC_VECTOR (7 DOWNTO 0);
                signal internal_upstream_waitrequest :  STD_LOGIC;
                signal set_use_registered :  STD_LOGIC;
                signal use_registered :  STD_LOGIC;

begin

  --upstream, which is an e_avalon_adapter_slave
  --waitrequest, which is an e_avalon_adapter_master
  process (waitrequest_clk, waitrequest_reset_n)
  begin
    if waitrequest_reset_n = '0' then
      internal_upstream_waitrequest <= std_logic'('0');
    elsif waitrequest_clk'event and waitrequest_clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        internal_upstream_waitrequest <= waitrequest_waitrequest;
      end if;
    end if;

  end process;

  upstream_endofpacket <= waitrequest_endofpacket;
  upstream_readdata <= waitrequest_readdata;
  upstream_readdatavalid <= waitrequest_readdatavalid;
  --set use registered, which is an e_assign
  set_use_registered <= waitrequest_waitrequest AND NOT internal_upstream_waitrequest;
  --use registered, which is an e_register
  process (waitrequest_clk, reset_n)
  begin
    if reset_n = '0' then
      use_registered <= std_logic'('0');
    elsif waitrequest_clk'event and waitrequest_clk = '1' then
      if (std_logic_vector'("00000000000000000000000000000001")) /= std_logic_vector'("00000000000000000000000000000000") then 
        if std_logic'((NOT waitrequest_waitrequest AND internal_upstream_waitrequest)) = '1' then 
          use_registered <= std_logic'('0');
        elsif std_logic'(set_use_registered) = '1' then 
          use_registered <= Vector_To_Std_Logic(-SIGNED(std_logic_vector'("00000000000000000000000000000001")));
        end if;
      end if;
    end if;

  end process;

  process (waitrequest_clk)
  begin
    if waitrequest_clk'event and waitrequest_clk = '1' then
      if std_logic'(set_use_registered) = '1' then 
        d1_upstream_address <= upstream_address;
      end if;
    end if;

  end process;

  waitrequest_address <= A_WE_StdLogicVector((std_logic'((use_registered)) = '1'), d1_upstream_address, upstream_address);
  process (waitrequest_clk)
  begin
    if waitrequest_clk'event and waitrequest_clk = '1' then
      if std_logic'(set_use_registered) = '1' then 
        d1_upstream_arbiterlock <= upstream_arbiterlock;
      end if;
    end if;

  end process;

  waitrequest_arbiterlock <= A_WE_StdLogic((std_logic'((use_registered)) = '1'), d1_upstream_arbiterlock, upstream_arbiterlock);
  process (waitrequest_clk)
  begin
    if waitrequest_clk'event and waitrequest_clk = '1' then
      if std_logic'(set_use_registered) = '1' then 
        d1_upstream_arbiterlock2 <= upstream_arbiterlock2;
      end if;
    end if;

  end process;

  waitrequest_arbiterlock2 <= A_WE_StdLogic((std_logic'((use_registered)) = '1'), d1_upstream_arbiterlock2, upstream_arbiterlock2);
  process (waitrequest_clk)
  begin
    if waitrequest_clk'event and waitrequest_clk = '1' then
      if std_logic'(set_use_registered) = '1' then 
        d1_upstream_burstcount <= upstream_burstcount;
      end if;
    end if;

  end process;

  waitrequest_burstcount <= A_WE_StdLogic((std_logic'((use_registered)) = '1'), d1_upstream_burstcount, upstream_burstcount);
  process (waitrequest_clk)
  begin
    if waitrequest_clk'event and waitrequest_clk = '1' then
      if std_logic'(set_use_registered) = '1' then 
        d1_upstream_byteenable <= upstream_byteenable;
      end if;
    end if;

  end process;

  waitrequest_byteenable <= A_WE_StdLogic((std_logic'((use_registered)) = '1'), d1_upstream_byteenable, upstream_byteenable);
  process (waitrequest_clk)
  begin
    if waitrequest_clk'event and waitrequest_clk = '1' then
      if std_logic'(set_use_registered) = '1' then 
        d1_upstream_chipselect <= upstream_chipselect;
      end if;
    end if;

  end process;

  waitrequest_chipselect <= A_WE_StdLogic((std_logic'((use_registered)) = '1'), d1_upstream_chipselect, upstream_chipselect);
  process (waitrequest_clk)
  begin
    if waitrequest_clk'event and waitrequest_clk = '1' then
      if std_logic'(set_use_registered) = '1' then 
        d1_upstream_debugaccess <= upstream_debugaccess;
      end if;
    end if;

  end process;

  waitrequest_debugaccess <= A_WE_StdLogic((std_logic'((use_registered)) = '1'), d1_upstream_debugaccess, upstream_debugaccess);
  process (waitrequest_clk)
  begin
    if waitrequest_clk'event and waitrequest_clk = '1' then
      if std_logic'(set_use_registered) = '1' then 
        d1_upstream_nativeaddress <= upstream_nativeaddress;
      end if;
    end if;

  end process;

  waitrequest_nativeaddress <= A_WE_StdLogicVector((std_logic'((use_registered)) = '1'), d1_upstream_nativeaddress, upstream_nativeaddress);
  process (waitrequest_clk)
  begin
    if waitrequest_clk'event and waitrequest_clk = '1' then
      if std_logic'(set_use_registered) = '1' then 
        d1_upstream_read <= upstream_read;
      end if;
    end if;

  end process;

  waitrequest_read <= A_WE_StdLogic((std_logic'((use_registered)) = '1'), d1_upstream_read, upstream_read);
  process (waitrequest_clk)
  begin
    if waitrequest_clk'event and waitrequest_clk = '1' then
      if std_logic'(set_use_registered) = '1' then 
        d1_upstream_write <= upstream_write;
      end if;
    end if;

  end process;

  waitrequest_write <= A_WE_StdLogic((std_logic'((use_registered)) = '1'), d1_upstream_write, upstream_write);
  process (waitrequest_clk)
  begin
    if waitrequest_clk'event and waitrequest_clk = '1' then
      if std_logic'(set_use_registered) = '1' then 
        d1_upstream_writedata <= upstream_writedata;
      end if;
    end if;

  end process;

  waitrequest_writedata <= A_WE_StdLogicVector((std_logic'((use_registered)) = '1'), d1_upstream_writedata, upstream_writedata);
  --vhdl renameroo for output signals
  upstream_waitrequest <= internal_upstream_waitrequest;

end europa;

