library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;


entity distortion is
port (
	clk : in std_logic;
	reset_n : in std_logic;
	data_enable : in std_logic;
	distortion_enable : in std_logic;
	
	data_in : in std_logic_vector(15 downto 0);
	data_out : out std_logic_vector(15 downto 0);
	clip : in std_logic_vector(15 downto 0);
	data_ready : out std_logic

);
end distortion;
	
architecture rtl of distortion is
--	signal data_in_buf : std_logic_vector(15 downto 0);
--	signal data_out_buf : std_logic_vector(15 downto 0);
	signal cut_value : std_logic_vector(15 downto 0); 
--	constant cut_value := X"3FFF";

begin

	cut_value <= clip;

	process(clk, reset_n)
	begin
	if(reset_n = '0') then
		data_out <= (others => '0');
	elsif ( clk'event and clk = '1') then
		if(data_enable = '1') then
			if(distortion_enable = '1') then	
				if(data_in(15) = '1') then
					if((not data_in(14 downto 0)) > cut_value(14 downto 0)) then
						data_out <= '1' & (not cut_value(14 downto 0));
					else
						data_out <= data_in;
					end if;
				else
					if(data_in(14 downto 0) > cut_value(14 downto 0)) then
						data_out <= '0' & cut_value(14 downto 0);
					else
						data_out <= data_in;
					end if;
				end if;
			else
				data_out <= data_in;
			end if;
			data_ready <= '1';
		else
			data_ready <= '0';
		end if;
	end if;
	end process;

end architecture;
