library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity distortion_TB is
end distortion_TB;


architecture rtl of distortion_TB is

	signal clk : std_logic;
	signal reset_n : std_logic;
	signal data_ready : std_logic;
	signal data_request : std_logic;
	
	signal data_in : std_logic_vector(15 downto 0);
	signal data_out : std_logic_vector(15 downto 0);


component distortion is
port (
	clk : in std_logic;
	reset_n : in std_logic;
	data_ready : in std_logic;
	data_request : in std_logic;
	
	data_in : in std_logic_vector(15 downto 0);
	data_out : out std_logic_vector(15 downto 0)
);
end component;

begin

 V1: distortion port map(
	clk => clk,
	reset_n => reset_n,
	data_ready => data_ready,
	data_request => data_request,
	
	data_in  => data_in,
	data_out => data_out
);


process
begin
	reset_n <= '0';
	wait for 20 ns;
	reset_n<= '1';
	wait;
end process;

process
begin
	clk <= '0';
	wait for 5 ns;

	loop
			clk <= '1';
			wait for 5 ns;
			clk <= '0';
			wait for 5 ns;
	end loop;
end process;


process
begin
	loop
		wait for 20 ns;
		data_ready <= '1';
		data_in <= X"2F37";
		data_request <= '1';
		wait for 10 ns;
		data_ready <= '0';
		data_request <= '0';
		wait for 230 ns;
		data_ready <= '1';
		data_in <= X"8FFF";
		data_request <= '1';
		wait for 10 ns;
		data_ready <= '0';
		data_request <= '0';
		wait for 230 ns;
		data_ready <= '1';
		data_in <= X"3F37";
		data_request <= '1';
		wait for 10 ns;
		data_ready <= '0';
		data_request <= '0';
		wait for 230 ns;
		data_ready <= '1';
		data_in <= X"0023";
		data_request <= '1';
		wait for 10 ns;
		data_ready <= '0';
		data_request <= '0';
		wait for 230 ns;
		data_ready <= '1';
		data_in <= X"2724";
		data_request <= '1';
		wait for 10 ns;
		data_ready <= '0';
		data_request <= '0';
		wait for 230 ns;
		data_ready <= '1';
		data_in <= X"8F25";
		data_request <= '1';
		wait for 10 ns;
		data_ready <= '0';
		data_request <= '0';
		wait for 230 ns;
		data_ready <= '1';
		data_in <= X"FF12";
		data_request <= '1';
		wait for 10 ns;
		data_ready <= '0';
		data_request <= '0';
		wait for 230 ns;
	end loop;
end process;
end architecture;
