library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;


entity sine_table_TB is
end sine_table_TB;

architecture rtl of sine_table_TB is

	component sine_table is
	port (
		clk : in std_logic;
		reset_n : in std_logic;
		data_request : in std_logic;
		amplitude : in std_logic_vector (2 downto 0);
		addr : in std_logic_vector (12 downto 0);
	
		data_out : out std_logic_vector(11 downto 0)
		
	);
	end component;

	signal clk : std_logic;
	signal reset_n : std_logic;
	signal data_request : std_logic;
	signal amplitude : std_logic_vector (2 downto 0);
	signal addr : std_logic_vector (12 downto 0);	
	signal data_out : std_logic_vector(11 downto 0);

begin

	S1: sine_table port map (
		clk => clk,
		reset_n => reset_n,
		data_request => data_request,
		amplitude => amplitude,
		addr => addr,
		data_out => data_out		
	);

	process
	begin
		clk <='0';
		reset_n <= '0';
		wait for 5 ns;
		clk <= '1';
		wait for 5 ns;
		clk <='0';
		reset_n <= '1';
		wait for 5 ns;
		loop
			clk <='1';
			wait for 5 ns;
			clk <='0';
			wait for 5 ns;
		end loop;
	end process;
	
	process
	begin
		addr <= "0000000000000";
		amplitude <= "010";
		wait for 5 ns;
		data_request <= '1';
		loop
			if(addr = "1011101110000") then
				addr <= "0000000000000";
			else
				addr <= addr + 1; 
			end if;
			wait for 10 ns;
--			data_request <= '0';
--			wait for 10 ns;
		end loop;	
	end process;
end rtl;
